//============================================================================//
//                                   					  (c) 2002 Robert Papis    //
// Autor    : Robert Papis                                                    //
// Projekt  : Smoki                                                           //
// Plik     : dggraph.cpp                                                     //
// Utworzony: 28.05.2002                                                      //
//                                                                            //
// Opis     : Modu fun graficznych	          		            					//
// Pomysy  :                                                                 //
// Zmiany   :                                                                 //
//                                                                            //
//============================================================================//

#define bool int
#define true 1
#define false 0

const COL_AREA  		= BROWN;		// kolor ramki areny
const COL_BGINFO  	= BROWN;		// kolor ramki info
const COL_INFO  		= BLACK;		// kolor tesktu info

const COL_BGSTAT  	= BROWN;		// kolor ramki info
const COL_STAT  		= BLACK;		// kolor tesktu info

const COL_DRAG1  		= YELLOW;   // kolor piewrszego smoka
const COL_DRAG2  		= RED;		// kolor drugiego smoka

//------------------------------------------------------------------------------
// Wypisuj tekst w zadanym miejscu x,y przy uyciu domyslnego koloru
// arg: x,y - pooenie napisu w oknie
//      t - tekst
inline void putsxy(int x,int y,char* t)
{
	gotoxy(x,y);
	cprintf(t);
	//puts(t);
}

//------------------------------------------------------------------------------
// Rysuje pusty prostokt w zadanych kolorach
// arg: x1,y1 - lewy grny rg
//      x2,y2 - prawy dolny rg
//      col - domyslny kolor napisw
//     bgCol - kolor ta
void winCol(int x1, int y1, int x2, int y2, int col, int bgCol)
{
	window(1, 1, 80, 25);
	window(x1,y1, x2, y2);
	textcolor(col);
	textbackground(bgCol);
	clrscr();
}

//------------------------------------------------------------------------------
// Rysuje okno informacji o programie
void drawInfo()
{
	winCol(50,2,70,5, COL_INFO, COL_BGINFO);
	gotoxy(3,2); cprintf(NAME_AND_VERSION);
}

//------------------------------------------------------------------------------
void	drawTime(int time)
{
	winCol(59,13,65,13, COL_STAT, COL_BGSTAT);
	//gotoxy(0,0);
	cprintf("%d", time);
}

//------------------------------------------------------------------------------
// Rysuj komunikat w oknie punktw
// arg:
void drawPoints(int drag1, int drag2, int winSign=0, int winGame=0)
{
	winCol(51,10,69,11, COL_BGSTAT, COL_STAT);
	if (drag2==-1)
	{
		textcolor(COL_DRAG1);
		gotoxy(2,1); cprintf("  %s", dgPark[drag1].name);
		gotoxy(2,2); cprintf("   Solo test");
	}
	else
	{
		char win1 = ' ', gWin1 = ' ';
		char win2 = ' ', gWin2 = ' ';
		if (winSign==1) win1 = '!';
		if (winSign==2) win2 = '!';
		if (winGame==1) gWin1 = '!';
		if (winGame==2) gWin2 = '!';

		long col1 = (DGFSet.left == 0) ? COL_DRAG1 : COL_DRAG2;
		long col2 = (DGFSet.left == 0) ? COL_DRAG2 : COL_DRAG1;

		textcolor(col1);
		gotoxy(1,1); cprintf("%c%d%c%s(%d)", gWin1,
			DGFSet.points[0], win1, dgPark[drag1].name, DGFSet.sPoints[0]);
		textcolor(col2);
		gotoxy(1,2); cprintf("%c%d%c%s(%d)", gWin2,
			DGFSet.points[1], win2, dgPark[drag2].name, DGFSet.sPoints[1]);
	}
}

//------------------------------------------------------------------------------
// Rysuj okno statusu gry
// arg: dgState - stan gry
//      drag1 - dane smoka1
//      drag2 - dane smoka2
void drawStatusInfo(int drag1, int drag2, int winSign=0, int winGame=0)
{

	winCol(50,7,70,23, COL_STAT, COL_BGSTAT);
	gotoxy(4,2); cprintf("Runda %d/%d", DGFSet.fightNo, MAX_FIGTH);

	textcolor(COL_STAT);
	gotoxy(4,7); cprintf("Czas:");

	drawPoints(drag1, drag2, winSign, winGame);

}


//------------------------------------------------------------------------------
// Rysuj komunikat w oknie statusu
// arg: dgState - stan gry
void drawStatusMsg(char* msg)
{
	winCol(50,15,70,23, COL_STAT, COL_BGSTAT);
	gotoxy(4,2); cprintf("%s", msg);
}

//------------------------------------------------------------------------------
// Rysuj smoka
// arg: drag - dane smoka
//      col - kolor
void drawDragon(TDGDragon drag, int col)
{
	int i, xDif, yDif;
	char bodyItem;
	textcolor(col);
	for(i=0; i<drag.size; i++)
	{
		gotoxy(drag.body[i].x, drag.body[i].y);
		if (i == drag.size-1) bodyItem = '.'; // ogon
		else
		{
			xDif = drag.body[i-1].x - drag.body[i+1].x;
			yDif = drag.body[i-1].y - drag.body[i+1].y;
			if (abs(xDif)==2) bodyItem = '\xc4';
			else if (abs(yDif)==2) bodyItem = '\xb3';
			else
			{
				if ((drag.body[i-1].x - drag.body[i].x)==0)
				{
					if((drag.body[i-1].y - drag.body[i].y)==-1)
					{
						if ((drag.body[i].x - drag.body[i+1].x)==1)
						{
							bodyItem = '\xd9';
						}
						else bodyItem = '\xc0';
					}
					else
					{
						if ((drag.body[i].x - drag.body[i+1].x)==1)
						{
							bodyItem = '\xbf';
						}
						else bodyItem = '\xda';
					}
				}
				else
				{
					if((drag.body[i-1].x - drag.body[i].x)==1)
					{
						if ((drag.body[i].y - drag.body[i+1].y)==1)
						{
							bodyItem = '\xc0';
						}
						else bodyItem = '\xda';
					}
					else
					{
						if ((drag.body[i].y - drag.body[i+1].y)==1)
						{
							bodyItem = '\xd9';
						}
						else bodyItem = '\xbf';
					}
				}
			}
			//bodyItem = 'o';
		}
		cprintf("%c", bodyItem);
	}

	// gowa
	int xHead = drag.body[0].x;
	int yHead = drag.body[0].y;
	putsxy(xHead, yHead, "o");

	if (drag.action==1) // smok zieje
	{
		int xFire, yFire;
		getFirePoint(xFire, yFire, drag);
		putsxy(xFire, yFire, "x");
	}
}

//------------------------------------------------------------------------------
// Rysuje arene ze smokami
// arg: dgState - stan gry
void drawArea(TDGState dgState)
{
	winCol(DGAREA_LEFT, DGAREA_TOP,
			 DGAREA_LEFT+DGAREA_W-1, DGAREA_TOP+DGAREA_H-1,
			 RED, BLACK);
	drawDragon(dgState.drag[0], YELLOW);
	if (dgState.count>1)	drawDragon(dgState.drag[1], RED);
	/* kalibracja
	textcolor(GREEN);
	putsxy(1,1,"x");
	putsxy(DGAREA_W, DGAREA_H,"x");
	*/
}


