//============================================================================//
//                                   					  (c) 2002 Robert Papis    //
// Autor    : Robert Papis                                                    //
// Projekt  : Smoki                                                           //
// Plik     : dragon.cpp                                                      //
// Utworzony: 07.05.2002                                                      //
//                                                                            //
// Opis     : Gwny plik projektu											            //
// Pomysy  :                                                                 //
// Zmiany   :                                                                 //
//                                                                            //
//============================================================================//
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <math.h>
#include "dragon.h"
#include "dggraph.h"
#include "dgcomp.h"

//------------------------------------------------------------------------------
// Definicje smokw
#include "dragons\d_rpa.cpp"
#include "dragons\a_1.cpp"
#include "dragons\a_2.cpp"
#include "dragons\a_3.cpp"
#include "dragons\a_4.cpp"
#include "dragons\a_5.cpp"
#include "dragons\b_1.cpp"
#include "dragons\b_2.cpp"
#include "dragons\b_3.cpp"
#include "dragons\b_4.cpp"
#include "dragons\b_5.cpp"


//------------------------------------------------------------------------------
// Zwracam punk - cel zionicia
// arg: xFire - do zwrcenia wartosci x
//  	  yFire - do zwrcenia wartosci x
//      drag - dane smoka
void getFirePoint(int &xFire, int &yFire, TDGDragon drag)
{
		if ((drag.body[0].x-drag.body[1].x)==1)
		{
			xFire = drag.body[0].x+1;
			yFire = drag.body[0].y;
		}
		else if ((drag.body[0].x-drag.body[1].x)==-1)
		{
			xFire = drag.body[0].x-1;
			yFire = drag.body[0].y;
		}
		else if ((drag.body[0].y-drag.body[1].y)==1)
		{
			xFire = drag.body[0].x;
			yFire = drag.body[0].y+1;
		}
		else if ((drag.body[0].y-drag.body[1].y)==-1)
		{
			xFire = drag.body[0].x;
			yFire = drag.body[0].y-1;
		}
}


//------------------------------------------------------------------------------
// Przesuwam smoka na planszy
// arg: no - nr smoka
//      pDS - stan gry
//      mv - ruch do wykonania
void MoveDragon(int no, TDGState*  pDS, int mv)
{
	if ((mv & 8)>0) // zieje ogniem
	{
		if (pDS->drag[no].power >= DG_GROW)
		{  // jeeli mog zia w tej kolejce
			pDS->drag[no].action = 1;
			pDS->drag[no].power  = -1;
		}
		else pDS->drag[no].action = 0;
		mv -= 8;
	}
	else pDS->drag[no].action = 0;
	pDS->drag[no].power++;

	int newX = pDS->drag[no].body[0].x;
	int newY = pDS->drag[no].body[0].y;

	if( pDS->drag[no].body[0].x > pDS->drag[no].body[1].x)
	{ // szed w lewo
		switch (mv)
		{
			case 1: newY++; break;
			case 2: newY--; break;
			default: newX++;
		}
	}
	if( pDS->drag[no].body[0].x < pDS->drag[no].body[1].x)
	{ // szed w prawo
		switch (mv)
		{
			case 1: newY--; break;
			case 2: newY++; break;
			default: newX--;
		}
	}
	if( pDS->drag[no].body[0].y > pDS->drag[no].body[1].y)
	{ // szed w d
		switch (mv)
		{
			case 1: newX--; break;
			case 2: newX++; break;
			default: newY++;
		}
	}
	if( pDS->drag[no].body[0].y < pDS->drag[no].body[1].y)
	{ // szed w gr
		switch (mv)
		{
			case 1: newX++; break;
			case 2: newX--; break;
			default: newY--;
		}
	}

	//newX = pDS->drag[no].body[0].x;
	//newY = pDS->drag[no].body[0].y;
	//newY++;

	if ((pDS->time % DG_GROW)==0) pDS->drag[no].size++; // wyduanie smoka
	for(int i=pDS->drag[no].size-1; i>0; i--)
	{
		pDS->drag[no].body[i].x = pDS->drag[no].body[i-1].x;
		pDS->drag[no].body[i].y = pDS->drag[no].body[i-1].y;
	}
	pDS->drag[no].body[0].x = newX;
	pDS->drag[no].body[0].y = newY;
}


//------------------------------------------------------------------------------
void SetBodyItem(TDGItem* it, int x, int y)
{
	it->x = x;
	it->y = y;
}

//------------------------------------------------------------------------------
void initGame(TDGState*  pDS)
{
	int x, y, k, dirX;
	pDS->time = 0;
	for(int i=0; i<pDS->count; i++)
	{
		pDS->drag[i].size = DG_BSIZE;
		dirX = ((i%2)==0) ? -1 : 1;
		x = DGAREA_W/2 + dirX*((rand()%5)-2 + 8);
		y = DGAREA_H/2 + (rand()%11)-5;

		for(k=0; k<DG_BSIZE; k++)
		{
			SetBodyItem(&pDS->drag[i].body[k], x, y);
			x += dirX;
		}
	}
	/* prbne parametry startowe dla partii wygranej przez zionicie :)
		dirX = -1;
		x = 16;
		y = 10;

		for(k=0; k<DG_BSIZE; k++)
		{
			SetBodyItem(&pDS->drag[0].body[k], x, y);
			x += dirX;
		}

		dirX = 1;
		x = 20;
		y = 8;

		for(k=0; k<DG_BSIZE; k++)
		{
			SetBodyItem(&pDS->drag[1].body[k], x, y);
			x += dirX;
		}
	*/
}

//------------------------------------------------------------------------------
// Czy atak dosign smoka no
// arg: pDS - wskanik na stan gry
//		  no - numer testowanego smoka
// ret: 0 nie stuteczny
//		  1 dosta
int isDragAction(TDGState* pDS, int no)
{
	// saby punkt
	int weakX = pDS->drag[no].body[1].x;
	int weakY = pDS->drag[no].body[1].y;

	for(int i=0; i<pDS->count; i++)
	{
		if(i==no) continue; // siebie nie mog poparzy
		if(pDS->drag[i].action ==1)
		{
			int fireX, fireY;
			getFirePoint(fireX, fireY, pDS->drag[i]);

			if ((weakX == fireX)&&(weakY == fireY))
			{
				return 1; // i po mnie :(
			}
		}
	}
	return 0; // nie tym razem
}

//------------------------------------------------------------------------------
// Czy nastpia kolizja
// arg: pDS - wskanik na stan gry
//		  no - numer testowanego smoka
// ret: 0 brak kolizji
//		  1 banda, 2 kolizja z sob, 3 kolizja z innym smokiem
int isDragCollision(TDGState* pDS, int no)
{
	int i,j;

	// czy wpadem na band
	if ((pDS->drag[no].body[0].x == 1)||
		 (pDS->drag[no].body[0].y == 1)||
		 (pDS->drag[no].body[0].x == DGAREA_W)||
		 (pDS->drag[no].body[0].y == DGAREA_H)
		 )
	{
		return 1;
	}
	// czy wpadem na smoka
	int xHead = pDS->drag[no].body[0].x;
	int yHead = pDS->drag[no].body[0].y;

	for(i=0; i<pDS->count; i++)
	{
		for(j=0; j<pDS->drag[i].size; j++)
		{
			if ((j==0)&&(i==no)) continue; // to moja gowa
			if ((xHead == pDS->drag[i].body[j].x)
				 &&(yHead == pDS->drag[i].body[j].y))
			{
				//printf("\n%d,%d,%d", no, i, j);
				return (i==no) ? 2 : 3; // kolozja z sob/innym smokiem
			}
		}
	}
	return 0;
}

//------------------------------------------------------------------------------
// Potyczka smokw: drag1 i drag2 lub solo test dla drag1
//arg: drag1 - nr(parkingowy) pierwszego smoka
//     drag2 - nr(parkingowy) drugiego smoka
int dragonFight(int drag1, int drag2 = -1)
{
	TDGState dgState;
	int res = 0;						// wynik 0 remis
	int i;
	int mv[DG_QDRAGON];				// proponowane ruchy
	int colResult[DG_QDRAGON];    // rezultaty kolizji
	int actResult[DG_QDRAGON];		// rezultaty atakw
	TDGDragonDescr* drag[DG_QDRAGON];   		// walczce smoki

	drag[0] = &dgPark[drag1];
	drag[1] = &dgPark[drag2];
	int stop = 0;
	DGFSet.currDelay = DG_DELAY;
	dgState.count = (drag2==-1) ? 1 : 2;

	initGame(&dgState);
	drawArea(dgState);

	while(stop <= 0)
	{
		if(stop == 0)
		{
			// Pytam o ruch
			for(i=0;i<dgState.count;i++)
			{
				mv[i] = drag[i]->funMove(dgState, i);
			}

			// Wykonuj ruch
			for(i=0;i<dgState.count;i++)
			{
				MoveDragon(i, &dgState, mv[i]);
			}

			drawArea(dgState);
			drawTime(DG_MAX_TIME-dgState.time);

			delay(DGFSet.currDelay);
			dgState.time++;
			if (dgState.time > DG_MAX_TIME) stop = 3; // koniec - czas mina

			// testowaniewe kolizji
			for(i=0; i<dgState.count; i++)
			{
				colResult[i] = isDragCollision(&dgState, i);
				if ( colResult[i] != 0) stop = (10*i)+colResult[i];
			}
			// testowanie zioni :)
			for(i=0; i<dgState.count; i++)
			{
				actResult[i] = isDragAction(&dgState, i);
				if ( actResult[i] != 0) stop = (100*i)+actResult[i];
			}
		}
		if (kbhit())
		{
			char ch = getch();
			if (ch == 'q')
			{
				stop = 2;  // koniec gry - przerwana gra
				res  = 3;
			}
			if (ch == 's') stop = -1; // stop
			if (ch == 'p') stop = 0;  // play
			if (ch == '-')	DGFSet.currDelay = int(DGFSet.currDelay*1.5);
			if (ch == '+')	DGFSet.currDelay = int(DGFSet.currDelay/1.2);
		}
		//if (dgState.drag[0].action==1) stop = 50;
	}
	DGFSet.lastTime = DG_MAX_TIME-dgState.time;

	if (stop==3) strcpy(DGFSet.msg, "Czas min\n Remis");
	if ((colResult[0]>0)&&(colResult[1]>0)) strcpy(DGFSet.msg, "Remis");
	else
	{
		strcpy(DGFSet.msg, "Win:");
		if(colResult[0]>0)
		{
			res = 2;
			strcat(DGFSet.msg, drag[1]->name);
		}
		else
		{
			res = 1;
			strcat(DGFSet.msg, drag[0]->name);
		}
	}
	return res;
}

//------------------------------------------------------------------------------
// Test smoka
//arg: drag1 - nr(parkingowy) pierwszego smoka

int dragonSolo(int drag1)
{
	DGFSet.left = 0;
	DGFSet.points[0]  = 0; DGFSet.points[1]  = 0;
	DGFSet.sPoints[0] = 0; DGFSet.sPoints[1] = 0;
	DGFSet.fightNo = 1;
	drawStatusMsg(dgPark[drag1].name);

	dragonFight(drag1, -1);
	while(!kbhit());
}

//------------------------------------------------------------------------------
// Pojedynek smokw: drag1 i drag2
//arg: drag1 - nr(parkingowy) pierwszego smoka
//     drag2 - nr(parkingowy) drugiego smoka
int dragonFightSet(int drag1, int drag2)
{
	int res, wRes = 0;
	int winSign;
	int wins[DG_QDRAGON]= {0}; // zwyciskie potyczki
	DGFSet.left = rand()%2;
	DGFSet.points[0]  = 0; DGFSet.points[1]  = 0;
	DGFSet.sPoints[0] = 0; DGFSet.sPoints[1] = 0;

	for(DGFSet.fightNo=1; DGFSet.fightNo<=MAX_FIGTH; DGFSet.fightNo++)
	{
		winSign = 0;
		drawStatusInfo(drag1, drag2);
		res = (DGFSet.left == 0) ? dragonFight(drag1, drag2) : dragonFight(drag2, drag1);
		if (res == 3) return 0;
		if(res>0) // przyznano punkt
		{
			if (((DGFSet.left == 0)&&(res==1))||((DGFSet.left == 1)&&(res==2)))
			{
				DGFSet.points[0]++;
				DGFSet.sPoints[0] += DGFSet.lastTime;
				winSign = 1;
			}
			if (((DGFSet.left == 1)&&(res==1))||((DGFSet.left == 0)&&(res==2)))
			{
				DGFSet.points[1]++;
				DGFSet.sPoints[1] += DGFSet.lastTime;
				winSign = 2;
			}
			if (DGFSet.points[0]+1<DGFSet.points[1]) wRes = 2;
			else if (DGFSet.points[0]>DGFSet.points[1]+1) wRes = 1;
			if (DGFSet.fightNo==MAX_FIGTH)
			{
				if (DGFSet.points[0]<DGFSet.points[1]) wRes = 2;
				else if (DGFSet.points[0]>DGFSet.points[1]) wRes = 1;
				else
				{
					if (DGFSet.sPoints[0]<DGFSet.sPoints[1]) wRes = 2;
					else if (DGFSet.sPoints[0]>DGFSet.sPoints[1]) wRes = 1;
				}
			}
			if(wRes>0) strcat(DGFSet.msg, "\n\r   Koniec!");
		}
		drawStatusInfo(drag1, drag2, winSign, wRes);
		drawTime(DGFSet.lastTime);
		drawStatusMsg(DGFSet.msg);
		DGFSet.left = (DGFSet.left==0)?1:0; // zamie strony
		while(!kbhit());
		if (wRes > 0) break;
	}
}


//------------------------------------------------------------------------------
// Parkowanie smoka
//arg: gdDesc - miesce na parkingu
//	 	 name - nazwa
//		 funMove - funkcja ruchu
void registerDragon(TDGDragonDescr* gdDesc, char* name, TDGFunMove funMove)
{
	strcpy(gdDesc->name, name);
	gdDesc->funMove = funMove;
}

//------------------------------------------------------------------------------
void main()
{
	randomize();
	winCol(DGAREA_LEFT-2, DGAREA_TOP-1,
			 DGAREA_LEFT+DGAREA_W+1, DGAREA_TOP+DGAREA_H,
			 BLACK, COL_AREA);
	drawInfo();

	// GRUPA A
	registerDragon(&dgPark[0], "Jamnik", DragonA_1_1);
	registerDragon(&dgPark[1], "Jamnik2", DragonA_1_1);
	registerDragon(&dgPark[2], "Smoczek", DragonA_2_1);
	registerDragon(&dgPark[3], "Smoczek2", DragonA_2_2);
	registerDragon(&dgPark[4], "Khaela", DragonA_3_1);
	registerDragon(&dgPark[5], "Khaela2", DragonA_3_1);
	registerDragon(&dgPark[6], "PaCyFiScI", DragonA_4_1);
	registerDragon(&dgPark[7], "PaCyFiScI2", DragonA_4_2);
	registerDragon(&dgPark[8], "A5_1", DragonA_5_1);
	registerDragon(&dgPark[9], "A5_2", DragonA_5_2);

	// GRUPA B
	registerDragon(&dgPark[10], "B1_1", DragonB_1_1);
	registerDragon(&dgPark[11], "B1_2", DragonB_1_1);
	registerDragon(&dgPark[12], "B2_1", DragonB_2_1);
	registerDragon(&dgPark[13], "B2_2", DragonB_2_2);
	registerDragon(&dgPark[14], "B3_1", DragonB_3_1);
	registerDragon(&dgPark[15], "B3_2", DragonB_3_2);
	registerDragon(&dgPark[16], "Athlon", DragonB_4_1);
	registerDragon(&dgPark[17], "Athlon2", DragonB_4_2);
	registerDragon(&dgPark[18], "Messiah", DragonB_5_1);
	registerDragon(&dgPark[19], "Messiah2", DragonB_5_2);


	//registerDragon(&dgPark[0], "Olo", getMoveDragon1);
	//registerDragon(&dgPark[1], "Kucyk", getMoveDragon2);

  /*
	dragonSolo(0); // solo test
	dragonSolo(2); // solo test
	dragonSolo(4); // solo test
	dragonSolo(6); // solo test
	dragonSolo(8); // solo test
	dragonSolo(10); // solo test
	dragonSolo(12); // solo test
	dragonSolo(14); // solo test
	dragonSolo(16); // solo test
	dragonSolo(18); // solo test
	*/
	dragonFightSet(4,19);

	//dragonFight(0,1);
	return;
	int m;
	m = 0; // modyfikator dla Grupy A
	//round1(m);
	//round2(m);
	//round3(m);
	//round4(m);
	//round5(m);

	m = 10; // modyfikator dla Grupy B
	//round1(m);
	//round2(m);
	//round3(m);
	//round4(m);
	//round5(m);

	// 1/8
	//dragonFightSet(,);
	//dragonFightSet(,);
	//dragonFightSet(,);
	//dragonFightSet(,);

	// 1/4
	//dragonFightSet(,);
	//dragonFightSet(,);
	//dragonFightSet(,);
	//dragonFightSet(,);

	//1/2
	//dragonFightSet(,);
	//dragonFightSet(,);

	// FINA
	//dragonFightSet(,);
}
