//============================================================================//
//                                   					  (c) 2002 Robert Papis    //
// Autor    : Robert Papis                                                    //
// Projekt  : Smoki                                                           //
// Plik     : dragon.h                                                        //
// Utworzony: 07.05.2002                                                      //
//                                                                            //
// Opis     : Gwne stae i stuktury projektu     					            //
// Pomysy  :                                                                 //
// Zmiany   :                                                                 //
//                                                                            //
//============================================================================//

const char NAME_AND_VERSION [] = "Smoki 1.0\n\r  (c)2002 Razmus";

const int MAX_DRAGON		= 20; 	// maxymalna ilosc smokw na parkingu
const int DG_QDRAGON		= 2;  	// ilosc smokw na w pojedynku

const int DG_MAX_TIME	= 5000;	// Maksymalny czs pojedynku
const int DG_DELAY		= 100;	// Standardowe opoznienie

const int DG_BSIZE		= 3;		// pocztkowa dugosc smoka
const int DG_GROW		   = 5;		// co ile kolejek przyrost

const int DGAREA_LEFT 	= 4;		// pooenie areny
const int DGAREA_TOP   	= 3;
const int DGAREA_H  		= 20;   	// wysokosc areny
const int DGAREA_W  		= 40;		// szerokosc areny

const int MAX_FIGTH		=  5;		// Ilo potyczek w pojedynku
const int DR_MAXSIZE		= DGAREA_H*DGAREA_W; // Max dugosc smoka


// Element "ciaa" smoka
struct TDGItem
{
	int x;
	int y;
};

// Smok - w opisie stanu gry
struct TDGDragon
{
	TDGItem body[DGAREA_H*DGAREA_W];		// ciao smoka
	int size;									// aktualna dugo
	int action;									// ostatnio wykonana akcja
   int power;									// ile mino od zioncia
};

// Stan gry
struct TDGState
{
	TDGDragon drag[DG_QDRAGON];			// tabela smokw
	int time;									// atkualny czas
	int count;									// ilo smokw w tabeli
};

struct TDGFightSet
{
	int fightNo;								// nr potyczki
	int points[DG_QDRAGON];	   			// ilo wygranych potyczek
	int sPoints[DG_QDRAGON];	   		// ilo maych punktw
	int lastTime;								// kidy zakoczono ostatni pojedynek
	int left;									// czy lewy jest po lewej :)
	char msg[200];								// komunikat o zakoczonym pojedynku
	int currDelay;								// opznienie
}DGFSet;

typedef int (*TDGFunMove)(TDGState, int);

// Opis smoka zgaszanego do turnieju
struct TDGDragonDescr
{
	char name[31];
	TDGFunMove funMove;
};

TDGDragonDescr dgPark[MAX_DRAGON]; // Parking dla smokw

void getFirePoint(int &xFire, int &yFire, TDGDragon drag);
int dragonFightSet(int drag1, int drag2);

